diff -Naur src.pgsql/backend/nodes/ondiskbitmapwords.c src.bizgres/backend/nodes/ondiskbitmapwords.c
--- src.pgsql/backend/nodes/ondiskbitmapwords.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/nodes/ondiskbitmapwords.c	2006-07-17 22:33:27.000000000 -0700
@@ -0,0 +1,103 @@
+/*-------------------------------------------------------------------------
+ *
+ * ondiskbitmapwords.c
+ * 	PostgreSQL
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ * IDENTIFICATION
+ *	$PostgreSQL$
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "nodes/ondiskbitmapwords.h"
+#include "nodes/execnodes.h"
+
+/*
+ * odbm_create() -- create an OnDiskBitmapWords object.
+ *
+ * The returned OnDiskBitmapWords contains 'maxNumOfWords' number of
+ * bitmap words. This number should be a multiple of
+ * BM_NUM_HRL_WORDS_PER_PAGE.
+ */
+OnDiskBitmapWords*
+odbm_create(uint32 maxNumOfWords)
+{
+	OnDiskBitmapWords* odbm;
+
+	/* we want to read the words in a page at once. */
+	Assert(maxNumOfWords%BM_NUM_OF_HRL_WORDS_PER_PAGE == 0);
+
+	odbm = (OnDiskBitmapWords*) palloc0(sizeof(OnDiskBitmapWords));
+
+	odbm->type = T_OnDiskBitmapWords; /*set NodeTag */
+	odbm->mcxt = CurrentMemoryContext;
+	_bitmap_init_batchwords(&(odbm->bitmapWords), maxNumOfWords, odbm->mcxt);
+
+	return odbm;
+}
+
+/*
+ * odbm_free() -- release the space for a OnDiskBitmapWords.
+ */
+void
+odbm_free(OnDiskBitmapWords* odbm)
+{
+	_bitmap_cleanup_batchwords(&(odbm->bitmapWords));
+
+	pfree(odbm);
+}
+
+/*
+ * odbm_set_bitmaptype() -- set if in-memory bitmap scan is used in a plan.
+ */
+void
+odbm_set_bitmaptype(Plan* plan, bool inmem)
+{
+	if(IsA(plan, BitmapAnd))
+		((BitmapAnd*)plan)->inmem = inmem;
+	else if (IsA(plan, BitmapOr))
+		((BitmapOr*)plan)->inmem = inmem;
+	else if (IsA(plan, BitmapIndexScan))
+		((BitmapIndexScan*)plan)->inmem = inmem;
+}
+
+/*
+ * odbm_set_child_resultnode() -- set 'resultOdbm' in a child node plan
+ *   state 'ps' to a given 'odbm'.
+ */
+void 
+odbm_set_child_resultnode(struct PlanState* ps, OnDiskBitmapWords* odbm)
+{
+	if (IsA(ps, BitmapAndState))
+		((BitmapAndState*)ps)->resultOdbm = odbm;
+	else if (IsA(ps, BitmapOrState))
+		((BitmapOrState*)ps)->resultOdbm = odbm;
+	else if (IsA(ps, BitmapIndexScanState))
+		((BitmapIndexScanState*)ps)->odbiss_result = odbm;
+	else
+		elog(ERROR, "wrong type in the subplan");
+}
+
+/*
+ * odbm_res_create() -- create an BMIterateResult instance.
+ */
+BMIterateResult*
+odbm_res_create(OnDiskBitmapWords* odbm)
+{
+	BMIterateResult* odbmres =
+		MemoryContextAllocZero(odbm->mcxt, sizeof(BMIterateResult));
+
+	return odbmres;
+}
+
+/*
+ * odbm_res_free() -- free an BMIterateResult instance.
+ */
+void
+odbm_res_free(BMIterateResult* odbmres)
+{
+	if (odbmres != NULL)
+		pfree(odbmres);
+}
diff -Naur src.pgsql/backend/optimizer/plan/createplan.c src.bizgres/backend/optimizer/plan/createplan.c
--- src.pgsql/backend/optimizer/plan/createplan.c	2006-07-17 17:05:14.000000000 -0700
+++ src.bizgres/backend/optimizer/plan/createplan.c	2006-07-17 22:33:23.000000000 -0700
@@ -78,11 +78,11 @@
 static void copy_plan_costsize(Plan *dest, Plan *src);
 static SeqScan *make_seqscan(List *qptlist, List *qpqual, Index scanrelid);
 static IndexScan *make_indexscan(List *qptlist, List *qpqual, Index scanrelid,
-			   Oid indexid, List *indexqual, List *indexqualorig,
+			   Oid indexid, Oid indexam, List *indexqual, List *indexqualorig,
 			   List *indexstrategy, List *indexsubtype,
 			   ScanDirection indexscandir);
 static BitmapIndexScan *make_bitmap_indexscan(Index scanrelid, Oid indexid,
-					  List *indexqual,
+					  Oid indexam, List *indexqual,
 					  List *indexqualorig,
 					  List *indexstrategy,
 					  List *indexsubtype);
@@ -793,6 +793,7 @@
 	List	   *indexquals = best_path->indexquals;
 	Index		baserelid = best_path->path.parent->relid;
 	Oid			indexoid = best_path->indexinfo->indexoid;
+	Oid			indexam = best_path->indexinfo->relam;
 	List	   *qpqual;
 	List	   *stripped_indexquals;
 	List	   *fixed_indexquals;
@@ -903,6 +904,7 @@
 							   qpqual,
 							   baserelid,
 							   indexoid,
+							   indexam,
 							   fixed_indexquals,
 							   stripped_indexquals,
 							   indexstrategy,
@@ -1172,6 +1174,7 @@
 		/* then convert to a bitmap indexscan */
 		plan = (Plan *) make_bitmap_indexscan(iscan->scan.scanrelid,
 											  iscan->indexid,
+											  iscan->indexam,
 											  iscan->indexqual,
 											  iscan->indexqualorig,
 											  iscan->indexstrategy,
@@ -1986,6 +1989,7 @@
 			   List *qpqual,
 			   Index scanrelid,
 			   Oid indexid,
+			   Oid indexam,
 			   List *indexqual,
 			   List *indexqualorig,
 			   List *indexstrategy,
@@ -2014,6 +2018,7 @@
 static BitmapIndexScan *
 make_bitmap_indexscan(Index scanrelid,
 					  Oid indexid,
+					  Oid indexam,
 					  List *indexqual,
 					  List *indexqualorig,
 					  List *indexstrategy,
@@ -2029,10 +2034,15 @@
 	plan->righttree = NULL;
 	node->scan.scanrelid = scanrelid;
 	node->indexid = indexid;
+	node->indexam = indexam;
 	node->indexqual = indexqual;
 	node->indexqualorig = indexqualorig;
 	node->indexstrategy = indexstrategy;
 	node->indexsubtype = indexsubtype;
+	if (node->indexam == BITMAP_AM_OID)
+		node->inmem = false;
+	else
+		node->inmem = true;
 
 	return node;
 }
@@ -2055,6 +2065,15 @@
 	node->scan.scanrelid = scanrelid;
 	node->bitmapqualorig = bitmapqualorig;
 
+	if (IsA(lefttree, BitmapIndexScan))
+		node->inmem = (((BitmapIndexScan*)lefttree)->indexam != BITMAP_AM_OID);
+	else if (IsA(lefttree, BitmapAnd))
+		node->inmem = ((BitmapAnd*)lefttree)->inmem;
+	else if (IsA(lefttree, BitmapOr))
+		node->inmem = ((BitmapOr*)lefttree)->inmem;
+	else
+		node->inmem = true;
+
 	return node;
 }
 
@@ -2166,6 +2185,7 @@
 {
 	BitmapAnd  *node = makeNode(BitmapAnd);
 	Plan	   *plan = &node->plan;
+	ListCell   *subnode;
 
 	/* cost should be inserted by caller */
 	plan->targetlist = NIL;
@@ -2174,6 +2194,32 @@
 	plan->righttree = NULL;
 	node->bitmapplans = bitmapplans;
 
+	node->inmem = false;
+	foreach(subnode, bitmapplans)
+	{
+		Plan *subplan = (Plan *) lfirst(subnode);
+		if (IsA(subplan, BitmapIndexScan) &&
+			((BitmapIndexScan *)subplan)->indexam != BITMAP_AM_OID)
+		{
+			node->inmem = true;
+			break;
+		}
+
+		else if (IsA(subplan, BitmapAnd) &&
+				 ((BitmapAnd *)subplan)->inmem)
+		{
+			node->inmem = true;
+			break;
+		}
+			
+		else if (IsA(subplan, BitmapOr) &&
+				 ((BitmapOr *)subplan)->inmem)
+		{
+			node->inmem = true;
+			break;
+		}
+	}
+
 	return node;
 }
 
@@ -2182,6 +2228,7 @@
 {
 	BitmapOr   *node = makeNode(BitmapOr);
 	Plan	   *plan = &node->plan;
+	ListCell   *subnode;
 
 	/* cost should be inserted by caller */
 	plan->targetlist = NIL;
@@ -2190,6 +2237,32 @@
 	plan->righttree = NULL;
 	node->bitmapplans = bitmapplans;
 
+	node->inmem = false;
+	foreach(subnode, bitmapplans)
+	{
+		Plan *subplan = (Plan *) lfirst(subnode);
+		if (IsA(subplan, BitmapIndexScan) &&
+			((BitmapIndexScan *)subplan)->indexam != BITMAP_AM_OID)
+		{
+			node->inmem = true;
+			break;
+		}
+
+		else if (IsA(subplan, BitmapAnd) &&
+				 ((BitmapAnd *)subplan)->inmem)
+		{
+			node->inmem = true;
+			break;
+		}
+			
+		else if (IsA(subplan, BitmapOr) &&
+				 ((BitmapOr *)subplan)->inmem)
+		{
+			node->inmem = true;
+			break;
+		}
+	}
+
 	return node;
 }
 
diff -Naur src.pgsql/backend/utils/adt/arrayfuncs.c src.bizgres/backend/utils/adt/arrayfuncs.c
--- src.pgsql/backend/utils/adt/arrayfuncs.c	2006-07-17 17:05:08.000000000 -0700
+++ src.bizgres/backend/utils/adt/arrayfuncs.c	2006-07-17 22:33:09.000000000 -0700
@@ -3148,6 +3148,12 @@
 	PG_RETURN_INT32(array_cmp(fcinfo));
 }
 
+Datum
+bmarraycmp(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_INT32(array_cmp(fcinfo));
+}
+
 /*
  * array_cmp()
  * Internal comparison function for arrays.
diff -Naur src.pgsql/backend/utils/adt/float.c src.bizgres/backend/utils/adt/float.c
--- src.pgsql/backend/utils/adt/float.c	2006-07-17 17:05:08.000000000 -0700
+++ src.bizgres/backend/utils/adt/float.c	2006-07-17 22:33:10.000000000 -0700
@@ -946,6 +946,15 @@
 	PG_RETURN_INT32(float4_cmp_internal(arg1, arg2));
 }
 
+Datum
+bmfloat4cmp(PG_FUNCTION_ARGS)
+{
+	float4		arg1 = PG_GETARG_FLOAT4(0);
+	float4		arg2 = PG_GETARG_FLOAT4(1);
+
+	PG_RETURN_INT32(float4_cmp_internal(arg1, arg2));
+}
+
 /*
  *		float8{eq,ne,lt,le,gt,ge}		- float8/float8 comparison operations
  */
@@ -1043,6 +1052,15 @@
 }
 
 Datum
+bmfloat8cmp(PG_FUNCTION_ARGS)
+{
+	float8		arg1 = PG_GETARG_FLOAT8(0);
+	float8		arg2 = PG_GETARG_FLOAT8(1);
+
+	PG_RETURN_INT32(float8_cmp_internal(arg1, arg2));
+}
+
+Datum
 btfloat48cmp(PG_FUNCTION_ARGS)
 {
 	float4		arg1 = PG_GETARG_FLOAT4(0);
@@ -1053,6 +1071,16 @@
 }
 
 Datum
+bmfloat48cmp(PG_FUNCTION_ARGS)
+{
+	float4		arg1 = PG_GETARG_FLOAT4(0);
+	float8		arg2 = PG_GETARG_FLOAT8(1);
+
+	/* widen float4 to float8 and then compare */
+	PG_RETURN_INT32(float8_cmp_internal(arg1, arg2));
+}
+
+Datum
 btfloat84cmp(PG_FUNCTION_ARGS)
 {
 	float8		arg1 = PG_GETARG_FLOAT8(0);
@@ -1062,6 +1090,15 @@
 	PG_RETURN_INT32(float8_cmp_internal(arg1, arg2));
 }
 
+Datum
+bmfloat84cmp(PG_FUNCTION_ARGS)
+{
+	float8		arg1 = PG_GETARG_FLOAT8(0);
+	float4		arg2 = PG_GETARG_FLOAT4(1);
+
+	/* widen float4 to float8 and then compare */
+	PG_RETURN_INT32(float8_cmp_internal(arg1, arg2));
+}
 
 /*
  *		===================
diff -Naur src.pgsql/backend/utils/adt/nabstime.c src.bizgres/backend/utils/adt/nabstime.c
--- src.pgsql/backend/utils/adt/nabstime.c	2006-07-17 17:05:08.000000000 -0700
+++ src.bizgres/backend/utils/adt/nabstime.c	2006-07-17 22:33:10.000000000 -0700
@@ -454,6 +454,14 @@
 	PG_RETURN_INT32(abstime_cmp_internal(t1, t2));
 }
 
+Datum
+bmabstimecmp(PG_FUNCTION_ARGS)
+{
+	AbsoluteTime t1 = PG_GETARG_ABSOLUTETIME(0);
+	AbsoluteTime t2 = PG_GETARG_ABSOLUTETIME(1);
+
+	PG_RETURN_INT32(abstime_cmp_internal(t1, t2));
+}
 
 /* timestamp_abstime()
  * Convert timestamp to abstime.
@@ -1130,6 +1138,14 @@
 	PG_RETURN_INT32(reltime_cmp_internal(t1, t2));
 }
 
+Datum
+bmreltimecmp(PG_FUNCTION_ARGS)
+{
+	RelativeTime t1 = PG_GETARG_RELATIVETIME(0);
+	RelativeTime t2 = PG_GETARG_RELATIVETIME(1);
+
+	PG_RETURN_INT32(reltime_cmp_internal(t1, t2));
+}
 
 /*
  *		tintervalsame	- returns true iff tinterval i1 is same as tinterval i2
@@ -1266,6 +1282,14 @@
 	PG_RETURN_INT32(tinterval_cmp_internal(i1, i2));
 }
 
+Datum
+bmtintervalcmp(PG_FUNCTION_ARGS)
+{
+	TimeInterval i1 = PG_GETARG_TIMEINTERVAL(0);
+	TimeInterval i2 = PG_GETARG_TIMEINTERVAL(1);
+
+	PG_RETURN_INT32(tinterval_cmp_internal(i1, i2));
+}
 
 /*
  *		tintervalleneq	- returns true iff length of tinterval i is equal to
diff -Naur src.pgsql/backend/utils/adt/selfuncs.c src.bizgres/backend/utils/adt/selfuncs.c
--- src.pgsql/backend/utils/adt/selfuncs.c	2006-07-17 17:05:09.000000000 -0700
+++ src.bizgres/backend/utils/adt/selfuncs.c	2006-07-17 22:33:10.000000000 -0700
@@ -4949,3 +4949,22 @@
 
 	PG_RETURN_VOID();
 }
+
+Datum
+bmcostestimate(PG_FUNCTION_ARGS)
+{
+	Query	   *root = (Query *) PG_GETARG_POINTER(0);
+	IndexOptInfo *index = (IndexOptInfo *) PG_GETARG_POINTER(1);
+	List	   *indexQuals = (List *) PG_GETARG_POINTER(2);
+	RelOptInfo *outer_rel = (RelOptInfo *) PG_GETARG_POINTER(3);
+	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(4);
+	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(5);
+	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(6);
+	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(7);
+
+	genericcostestimate(root, index, indexQuals, outer_rel, 0.0, 
+						indexStartupCost, indexTotalCost,
+						indexSelectivity, indexCorrelation);
+
+	PG_RETURN_VOID();
+}
diff -Naur src.pgsql/backend/utils/adt/varlena.c src.bizgres/backend/utils/adt/varlena.c
--- src.pgsql/backend/utils/adt/varlena.c	2006-07-17 17:05:09.000000000 -0700
+++ src.bizgres/backend/utils/adt/varlena.c	2006-07-17 22:33:11.000000000 -0700
@@ -1098,6 +1098,20 @@
 	PG_RETURN_INT32(result);
 }
 
+Datum
+bmtextcmp(PG_FUNCTION_ARGS)
+{
+	text		*arg1 = PG_GETARG_TEXT_P(0);
+	text		*arg2 = PG_GETARG_TEXT_P(1);
+	int32		result;
+
+	result = text_cmp(arg1, arg2);
+
+	PG_FREE_IF_COPY(arg1, 0);
+	PG_FREE_IF_COPY(arg2, 1);
+
+	PG_RETURN_INT32(result);
+}
 
 Datum
 text_larger(PG_FUNCTION_ARGS)
@@ -1265,6 +1279,21 @@
 	PG_RETURN_INT32(result);
 }
 
+Datum
+bmtext_pattern_cmp(PG_FUNCTION_ARGS)
+{
+	text		*arg1 = PG_GETARG_TEXT_P(0);
+	text		*arg2 = PG_GETARG_TEXT_P(1);
+	int			result;
+
+	result = internal_text_pattern_compare(arg1, arg2);
+
+	PG_FREE_IF_COPY(arg1, 0);
+	PG_FREE_IF_COPY(arg2, 1);
+
+	PG_RETURN_INT32(result);
+}
+
 
 /*-------------------------------------------------------------
  * byteaoctetlen
